###############################################################################
# GuestBookAdmin.pm                                                           #
###############################################################################
# Guestbook for YaBB 2.7.00                                                   #
# Version 0.6                                                                 #
# Author Thomas Mller & Derek Barnstorm                                      #
# =========================================================================== #
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 2.7.00                                                 #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2016 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by:  The YaBB Development Team                                     #
#               with assistance from the YaBB community.                      #
###############################################################################

$guestbookadminpmver = 'YaBB 2.7.00 $Revision: 0.8 $';
if ($action eq 'detailedversion') { return 1; }

if (!-e("$vardir/guestbook/GB_Settings.txt")) { GuestBookPage2(); }
require "$vardir/guestbook/GB_Settings.txt";

LoadLanguage('Mods/Guestbook');
get_template('Mods/Guestbook');

sub GuestBookPage {
    is_admin_or_gmod();

    if    (!$en_guestbook)       { $selgb1  = ' selected="selected"'; }
    elsif ($en_guestbook == 1)   { $selgb2  = ' selected="selected"'; }
    elsif ($en_guestbook == 2)   { $selgb3  = ' selected="selected"'; }
    if    (!$en_valimage)        { $selval1  = ' selected="selected"'; }
    elsif ($en_valimage == 1)    { $selval2  = ' selected="selected"'; }
    elsif ($en_valimage == 2)    { $selval3  = ' selected="selected"'; }
    if    ($en_gbspellcheck)     { $chkspellcheck = ' checked="checked" '; }
    if    ($en_gbcensor)         { $chkgbcensor = ' checked="checked" '; }
    if    ($en_gbbbcode)         { $chkgbbbcode = ' checked="checked" ';}
    if    ($en_gbsmilies)        { $chkgbsmilies = ' checked="checked" '; }
    if    ($en_gbemail)          { $chkgbemail = ' checked="checked" '; }
    if    ($en_gbmorefields)     { $chkgbmorefields = ' checked="checked" ' }

    $start = $INFO{'start'} || 0;
    if (!-e("$vardir/guestbook/guestbook.txt")) { fopen(GBOOK, ">$vardir/guestbook/guestbook.txt"); fclose(GBOOK); } 

    fopen(GBOOK, "<$vardir/guestbook/guestbook.txt") or fatal_error('cannot_open',"$vardir/guestbook/guestbook.txt", 1);
    @entries = <GBOOK>;
    fclose(GBOOK);

    $total_comments = @entries || 0;

    $number_of_messages = $#entries;
    $skip_messages      = $start;
    $counter            = 0;
    $displayedcounter   = 0;

    $gb_spellcheck = q{};
    if ( $enable_spell_check ) {
        $gb_spellcheck = $mygb_spellcheck;
        $gb_spellcheck =~ s/{yabb chkspellcheck}/$chkspellcheck/gsm;
    }

    $yymain .= $guestbook_admin_main;
    $yymain =~ s/{yabb selgb1}/$selgb1/gsm;
    $yymain =~ s/{yabb selgb2}/$selgb2/gsm;
    $yymain =~ s/{yabb selgb3}/$selgb3/gsm;
    $yymain =~ s/{yabb selval1}/$selval1/gsm;
    $yymain =~ s/{yabb selval2}/$selval2/gsm;
    $yymain =~ s/{yabb selval3}/$selval3/gsm;
    $yymain =~ s/{yabb gbspellcheck}/$gb_spellcheck/gsm;
    $yymain =~ s/{yabb chkgbcensor}/$chkgbcensor/gsm;
    $yymain =~ s/{yabb chkgbbbcode}/$chkgbbbcode/gsm;
    $yymain =~ s/{yabb chkgbsmilies}/$chkgbsmilies/gsm;
    $yymain =~ s/{yabb chkgbemail}/$chkgbemail/gsm;
    $yymain =~ s/{yabb chkgbmorefields}/$chkgbmorefields/gsm;

    $yytitle = $Guestbook_txt{'33'};
    $action_area = "guestbookpage";
    AdminTemplate();
    exit;
}

sub GuestBookPage2 {

    is_admin_or_gmod();

    $en_guestbook = $FORM{'en_guestbook'} || 0;
    $en_valimage = $FORM{'en_valimage'} || 0;
    $MaxGbMesLen = $FORM{'MaxGbMesLen'} || 1000;
    $maxadmindismes = $FORM{'maxadmindismes'} || 10;
    $maxdismes = $FORM{'maxdismes'} || 10;
    $en_gbspellcheck = $FORM{'en_gbspellcheck'} || 0;
    $en_gbcensor = $FORM{'en_gbcensor'} || 0;
    $en_gbbbcode = $FORM{'en_gbbbcode'} || 0;
    $en_gbsmilies = $FORM{'en_gbsmilies'} || 0;
    $en_gbemail = $FORM{'en_gbemail'} || 0;
    $en_gbmorefields = $FORM{'en_gbmorefields'} || 0;

    my $setfile = <<EOF;
###############################################################################
# Guestbook Configuration.txt (Guestbook Configuration Page)                  #
###############################################################################

\$en_guestbook = $en_guestbook;
\$en_valimage = $en_valimage;
\$MaxGbMesLen = $MaxGbMesLen;
\$maxadmindismes = $maxadmindismes;
\$maxdismes = $maxdismes;
\$en_gbspellcheck = $en_gbspellcheck;
\$en_gbcensor = $en_gbcensor;
\$en_gbbbcode = $en_gbbbcode;
\$en_gbsmilies = $en_gbsmilies;
\$en_gbemail = $en_gbemail;
\$en_gbmorefields = $en_gbmorefields;

1;
EOF

    fopen(FILE, ">$vardir/guestbook/GB_Settings.txt");
    print FILE $setfile;
    fclose(FILE);

    require Admin::NewSettings;
    SaveSettingsTo('Settings.pm');

    if ($action eq guestbookpage2) {
        $yySetLocation = qq~$adminurl?action=guestbookpage~;
        redirectexit();
    }
    return;
}

1;