###############################################################################
# GuestBook.pm                                                                #
###############################################################################
# Guestbook for YaBB 2.7.00                                                   #
# Version 0.5                                                                 #
# Author Thomas Mller & Derek Barnstorm                                      #
# Updated to 2.7.00 by Deborah Rorabaugh (Dandello)                           #
# =========================================================================== #
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 2.7.00                                                 #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2016 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by:  The YaBB Development Team                                     #
#               with assistance from the YaBB community.                      #
###############################################################################
use CGI::Carp qw(fatalsToBrowser);
$guestbookpmver = 'YaBB 2.7.00 $Revision: 0.7 $';
if ($action eq 'detailedversion') { return 1; }

if (-e "$vardir/guestbook/GB_Settings.txt") { require "$vardir/guestbook/GB_Settings.txt"; }
if ($en_valimage == 2 || ($iamguest && $en_valimage == 1)) { require Sources::Decoder; }
if (!$en_guestbook || ($iamguest && $en_guestbook != 1)) { fatal_error('not_allowed'); }

LoadLanguage('Mods/Guestbook');
LoadLanguage('Post');
LoadLanguage('Profile');
get_micon();
get_template('Mods/Guestbook');

sub GuestBook {
    $start = $INFO{'start'} || 0;

    fopen(GBOOK, "<$vardir/guestbook/guestbook.txt") or fatal_error('cannot_open',"$vardir/guestbook/guestbook.txt", 1);
    @entries = <GBOOK>;
    fclose(GBOOK);

    $total_comments = @entries || 0;

    $number_of_messages = $#entries;
    $skip_messages      = $start;
    $counter            = 0;
    $displayedcounter   = 0;
    Paginate();
    $gbcomment = q{};
    foreach my $line (reverse sort { $a <=> $b } @entries) {
    if ($counter >= $skip_messages && $displayedcounter < $maxdismes) {
        chomp @line;
        ($gb_date, $name, $location, $email, $website, $gb_icq, $gb_aim, $gb_yim, $gb_skype, $gb_myspace, $gb_facebook, $message, $gb_ip, $gb_gtalk, $gb_twitter, $gb_youtube ) = split /[|]/xsm, $line;
        if ($location) { $location = qq~<span style="font-weight: bold;">$Guestbook_txt{'01'}</span> $location<br />~; }
        else           { $location = q{}; }

        $gb_contact = q{};

        if ($email) {
            $email_img = qq~<img src="$micon_bg{'email'}" alt="$Guestbook_txt{'03'}" title="$Guestbook_txt{'03'}" />~;
            $gb_contact .= enc_eMail($email_img,$email,q{},q{});
            $gb_contact .= q{ };
        }
        if ($website)  {
            if ($website !~ /http:\/\//) { $website = qq~http://$website~; }
            $gb_contact .= qq~<a href="$website" target="_blank"><img src="$imagesdir/www.png" alt="$Guestbook_txt{'40'}" title="$Guestbook_txt{'40'}" /></a>~;
        }
        if ($gb_icq)  {
            if ($gb_icq !~ /http:\/\//) { $gb_icq = qq~http://web.icq.com/$gb_icq~; }
            $gb_contact .= qq~<a href="$gb_icq" target="_blank"><img src="$imagesdir/icqadd.gif" alt="ICQ" title="ICQ" /></a>~;
        }
        if ($gb_aim) {
             $gb_contact .= qq~<a href="aim:goim?screenname=$gb_aim" target="_blank"><img src="$imagesdir/aim.gif" alt="AIM" title="AIM" /></a>~;
        }
        if ($gb_yim)  {
           if ($gb_yim !~ /http:\/\//) { $gb_yim = qq~http://edit.yahoo.com/config/send_webmesg?.target=$gb_yim~; }
           $gb_contact .= qq~<a href="$gb_yim" target="_blank"><img src="$imagesdir/yim.gif" alt="YIM" title="YIM" /></a>~;
        }
        if ($gb_skype)  {
            $gb_contact .= qq~<a href="javascript:void(window.open('callto://$gb_skype','skype','height=80,width=340,menubar=no,toolbar=no,scrollbars=no'))" target="_blank"><img src="$imagesdir/skype.gif" alt="Skype" title="Skype" /></a>~;
        }
        if ($gb_myspace)  {
            if ($gb_myspace !~ /http:\/\//) { $gb_myspace = qq~http://www.myspace.com/$gb_myspace~; }
            $gb_contact .= qq~<a href="$gb_myspace" target="_blank"><img src="$imagesdir/myspace.gif" alt="My Space" title="My Space" /></a>~;
        }
        if ($gb_facebook)  {
            if ($gb_facebook !~ /http:\/\//) { $gb_facebook = qq~http://www.facebook.com/~ . ($gb_facebook !~ /\D/ ? "profile.php?id=" : q{}) . qq~$gb_facebook~; }
            $gb_contact .= qq~<a href="$gb_facebook" target="_blank"><img src="$imagesdir/facebook.gif" alt="Facebook" title="Facebook" /></a>~;
        }
        if ($gb_gtalk)  {
            $gb_contact .= qq~<a href="#" onclick="window.open('$scripturl?action=setgtalk;gtalkname=$user','','height=80,width=340,menubar=0,toolbar=0,scrollbars=0,resizable=1'); return false">$profile_txt{'825'} $gb_gtalk</a>~;
        }
        if ($gb_twitter)  {
            $gb_contact .= qq~<a href="http://twitter.com/$gb_twitter" target="_blank">$profile_txt{'576'}</a>~;
        }
        if ($gb_youtube)  {
            $gb_contact .= qq~<a href="http://www.youtube.com/$gb_youtube" target="_blank">$profile_txt{'579'} $gb_youtube</a>~;
        }

        if ($iamadmin || $iamfmod || ( $iamgmod && $gmod_access2{'ipban2'} eq 'on' ) ) {
            $gb_ip = qq~<img src="$micon_bg{'ip'}" alt="$Guestbook_txt{'41'}" title="$Guestbook_txt{'41'}" /> $gb_ip~;
        }
        else {
            $gb_ip = qq~<img src="$micon_bg{'ip'}" alt="$Guestbook_txt{'41'}" title="$Guestbook_txt{'41'}" /> $Guestbook_txt{'45'}~;
        }

        if ($en_gbcensor) {
            LoadCensorList();
            $name = Censor($name);
            $message = Censor($message);
        }

        wrap();
        if ($enable_ubbc) {
            enable_yabbc();
            DoUBBC();
        }
        wrap2();
        $deletelink = q{};
        $editlink = q{};
        if ( $iamadmin || $iamfmod || $iamgmod ) {
            $deletelink = qq~$Guestbook_txt{'30'} <input type="checkbox" name="delgbcheckbox" value="$gb_date" />~;
            $editlink = qq~[<a href="$script?action=editgbmessages;id=$gb_date">$Guestbook_txt{'54'}</a>]~;
        }

        $gb_date = timeformat($gb_date,0,0,0,1);
        $gbcomment .= $guestbookcomment;
        $gbcomment =~ s/{yabb gb_date}/$gb_date/gsm;
        $gbcomment =~ s/{yabb name}/$name/gsm;
        $gbcomment =~ s/{yabb location}/$location/gsm;
        $gbcomment =~ s/{yabb contact}/$gb_contact/gsm;
        $gbcomment =~ s/{yabb gb_ip}/$gb_ip/gsm;
        $gbcomment =~ s/{yabb message}/$message/gsm;
        $gbcomment =~ s/{yabb deletelink}/$deletelink/gsm;
        $gbcomment =~ s/{yabb editlink}/$editlink/gsm;

        $displayedcounter++;
        }
     $counter++;
    }
    $removegbmessages = q{};
    $removegbmessages_b = q{};
    if ( $iamadmin || $iamgmod || $iamfmod ) {
        $removegbmessages = qq~<form action="$scripturl?action=removegbmessages" method="post">~;
        $removegbmessages_b = $myremovegbmessages;
    }
    $yymain .= $guestbook;
    $yymain =~ s/{yabb removegbmessages}/$removegbmessages/gsm;
    $yymain =~ s/{yabb gbcomment}/$gbcomment/sm;
    $yymain =~ s/{yabb pageindex}/$pageindex/gsm;
    $yymain =~ s/{yabb total_comments}/$total_comments/gsm;
    $yymain =~ s/{yabb removegbmessages_b}/$removegbmessages_b/gsm;

    $yytitle = "$Guestbook_txt{'12'}";
    $yynavigation = qq~&rsaquo; $Guestbook_txt{'12'}~;
    template();
    return;
}

sub Paginate {
    # Build the page links list.
    $postdisplaynum = 3;  # max number of pages to display
    $max            = $number_of_messages + 1;
    $start          = $INFO{'start'} || 0;
    $start          = $start > $number_of_messages ? $number_of_messages : $start;
    $start          = (int($start / $maxdismes)) * $maxdismes;
    $tmpa           = 1;
    $tmpx           = int($max / $maxdismes);
    if ($start >= (($postdisplaynum - 1) * $maxdismes)) { $startpage = $start - (($postdisplaynum - 1) * $maxdismes); $tmpa = int($startpage / $maxdismes) + 1; }
    if ($max >= $start + ($postdisplaynum * $maxdismes)) { $endpage = $start + ($postdisplaynum * $maxdismes); }
    else { $endpage = $max }
    if ($startpage > 0) { $pageindex = qq~<a href="$scripturl?action=guestbook;start=0"><b>1</b></a>&nbsp;...&nbsp;~; }
    if ($startpage == $maxdismes) { $pageindex = qq~<a href="$scripturl?action=guestbook;start=0"><b>1</b></a>&nbsp;~; }

    for ($counter = $startpage; $counter < $endpage; $counter += $maxdismes) {
        $pageindex .= $start == $counter ? qq~<b>$tmpa</b>&nbsp;~ : qq~<a href="$scripturl?action=guestbook;start=$counter"><b>$tmpa</b></a>&nbsp;~;
        $tmpa++;
    }

    $tmpx    = $max - $maxdismes;
    $outerpn = int($tmpx / $maxdismes) + 0;
    $lastpn  = int($number_of_messages / $maxdismes) + 1;
    $lastptn = ($lastpn - 1) * $maxdismes;
    if ($endpage < $max - ($maxdismes)) { $pageindexadd = qq~&nbsp;...&nbsp;~; }
    if ($endpage != $max) { $pageindexadd .= qq~&nbsp;<a href="$scripturl?action=guestbook;start=$lastptn"><b>$lastpn</b></a>~; }
    $pageindex .= $pageindexadd;
}

sub SignGuestBook {
    require Sources::PostBox;
    require Sources::ContextHelp;
    ContextScript('post');
    my $guestbook_spellcheck = q{};
    if ($en_gbspellcheck && $enable_spell_check) {
        $yyinlinestyle .= googiea();
        $yyinlinestyle .= qq~\n<script type="text/javascript" src="$yyhtml_root/AJS.js"></script>~;
        my $userdefaultlang = (split(/-/, $abbr_lang))[0];
        $userdefaultlang ||= 'en';
        $guestbook_spellcheck .= googie($userdefaultlang);
    }

    if ($en_gbsmilies) {
        $gbsmilie_bar = smilies_list();
    }

    if ($en_gbbbcode) {
        $gbbbcode_bar .= postbox();
    }
    $gbbbcode_bar .= postbox2();
    $gbbbcode_bar .= postbox3();
    $gbbbcode_bar .= '<script src="$yyhtml_root/ajax.js" type="text/javascript"></script>';
    $gbbbcode .= my_check_prev();
    $gbbbcode .= qq~\n<script type="text/javascript">~;
    $gbbbcode .= my_liveprev();
    $gbbbcode .= qq~</script>\n~;

    if (!$iamguest) {
         $name = qq~ value="${$uid.$username}{'realname'}" onfocus="txtInFields(this, '${$uid.$username}{'realname'}');" onblur="txtInFields(this, '${$uid.$username}{'realname'}')"~;
    }

    $gbfields = q{};
    if ($en_gbmorefields) {
        $gbfields = $gbmorefields;
    }

    $gb_valid = q{};
    if ($en_valimage == 2 || ($iamguest && $en_valimage == 1)) {
    require Sources::Decoder;
        validation_code();
        $gb_valid .= $guestbook_valid;
        $gb_valid =~ s/{yabb flood_text}/$flood_text/gsm;
        $gb_valid =~ s/{yabb showcheck}/$showcheck/gsm;
    }

    $yymain .= $guestbooksign;
    $yymain =~ s/{yabb gbbbcode_bar}/$gbbbcode_bar/gsm;
    $yymain =~ s/{yabb guestbook_spellcheck}/$guestbook_spellcheck/gsm;
    $yymain =~ s/{yabb textfield}/$textfield/gsm;
    $yymain =~ s/{yabb gbsmilie_bar}/$gbsmilie_bar/gsm;
    $yymain =~ s/{yabb name}/$name/gsm;
    $yymain =~ s/{yabb email}/$email/gsm;
    $yymain =~ s/{yabb gb_valid}/$gb_valid/gsm;
    $yymain =~ s/{yabb gbfields}/$gbfields/gsm;
    $yymain .= $ctmain;
    $yymain .= $gbbbcode;

    $yytitle = qq~$Guestbook_txt{'09'}~;
    $yynavigation = qq~&rsaquo; $Guestbook_txt{'09'}~;
    template();
    return;

}

sub SignGuestBook2 {
    $name = $FORM{'name'};
    $location = $FORM{'location'};
    $email = $FORM{'email'};
    $website = $FORM{'website'};
    $gb_icq = $FORM{'gb_icq'};
    $gb_aim = $FORM{'gb_aim'};
    $gb_yim = $FORM{'gb_yim'};
    $gb_skype = $FORM{'gb_skype'};
    $gb_myspace = $FORM{'gb_myspace'};
    $gb_facebook = $FORM{'gb_facebook'};
    $gb_gtalk = $FORM{'gb_gtalk'};
    $gb_twitter = $FORM{'gb_twitter'};
    $gb_youtube = $FORM{'gb_youtube'};
    $message = $FORM{'message'};
    FromChars($message);
    ToHTML($message);
    $message =~ s/[\n\r]{1,2}/<br \/>/gsm;
    ToChars($message);

    if ($en_gbemail) {
        require Sources::Mailer;
        LoadLanguage('Email');
        $email_message = $FORM{'message'};
        $email_name    = $FORM{'name'};
        $email_message =~ s/\r(?=\n*)//g;
        $email_message =~ s~\[b\](.*?)\[/b\]~*$1*~isg;
        $email_message =~ s~\[i\](.*?)\[/i\]~/$1/~isg;
        $email_message =~ s~\[u\](.*?)\[/u\]~_$1_~isg;
        $email_message =~ s~\[.*?\]~~g;
        if ($en_gbcensor) {
            LoadCensorList();
            $email_name = Censor($email_name);
            $email_message = Censor($email_message);
        }
    }

    if ($name eq q{}) {fatal_error('no_name');}
    if ($message eq q{}) {fatal_error('no_message');}
    if ( length($email) > 100) {fatal_error('email_to_long');}
    if ($gb_icq !~ /^[0-9]*$/) {fatal_error('icq_only_numbers_allowed');}

    if ($en_valimage == 2 || ($iamguest && $en_valimage == 1)) { validation_check($FORM{'verification'}); }

    if ($en_gbemail) {
        my $gb_entry = template_email($new_gb_entry, {'gb_name' => $email_name, 'gb_message' => $email_message, 'gb_ip' => $user_ip});
        sendmail($webmaster_email, "$Guestbook_txt{'42'}", $gb_entry, "$mbname <$webmaster_email>");
    }

    $yymain .= $guestbook_thank;

    fopen(SET, ">>$vardir/guestbook/guestbook.txt") or fatal_error('cannot_open',"$vardir/guestbook/guestbook.txt", 1);
    print {SET} "$date|$name|$location|$email|$website|$gb_icq|$gb_aim|$gb_yim|$gb_skype|$gb_myspace|$gb_facebook|$message|$user_ip|$gb_gtalk|$gb_twitter|$gb_youtube|\n";
    fclose(SET);

    $yyinlinestyle = qq~<meta http-equiv="refresh" content="5; url=$scripturl?action=guestbook" />~;
    $yytitle = "$Guestbook_txt{'06'} - $thankyou_txt{'04'}";
    $yynavigation = qq~&rsaquo; $Guestbook_txt{'06'} &rsaquo; $thankyou_txt{'04'}~;
    template();
    return;
}

sub RemoveGBMessages {
    if ( !$iamadmin && !$iamgmod && !$iamfmod ) { fatal_error('no_access'); }
    (@delgbmessages) = split /,\s*/sm, $FORM{'delgbcheckbox'};

    fopen(GBOOK, "+<$vardir/guestbook/guestbook.txt") or fatal_error('cannot_open',"$vardir/guestbook/guestbook.txt", 1);
    @entries = <GBOOK>;

    for my $gbmessages_to_delete (@delgbmessages) {
        $line_count = 0;
        for my $line (@entries) {
            chomp;
            my ($gb_date, $name, $location, $email, $website, $gb_icq, $gb_aim, $gb_yim, $gb_skype, $gb_myspace, $gb_facebook, $message, $gb_ip, $gb_gtalk, $gb_twitter, $gb_youtube) = split /[|]/xsm, $line;

            $gb_id = $gb_date;

            if ($gb_date == $gbmessages_to_delete) {
                $line_number = $line_count;
                last;
            }
            $line_count++;
        }
        $entries[$line_number] = q{};
    }

    seek GBOOK, 0, 0;
    truncate GBOOK, 0;
    print GBOOK @entries;
    fclose(GBOOK);

    $yymain .= qq~<p class="center">$Guestbook_txt{'25'}<br /><br /><a href="$scripturl?action=guestbook">$Guestbook_txt{'26'}</a></p>~;
    template();
    return;
}

sub EditGBMessages {
    if ( !$iamadmin && !$iamgmod && !$iamfmod ) { fatal_error('no_access'); }

    $id = $INFO{'id'};
    my $gb_edit = q{};

    fopen(GBOOK, "<$vardir/guestbook/guestbook.txt") or fatal_error('cannot_open',"$vardir/guestbook/guestbook.txt", 1);
    @gb_messages = <GBOOK>;
    fclose(GBOOK);

    for my $message (@gb_messages) {
        chomp $message;
        if ($message =~ /$id/) {
            $gb_edit = $message; last;
        }
    }
    ($gb_date, $name, $location, $email, $website, $gb_icq, $gb_aim, $gb_yim, $gb_skype, $gb_myspace, $gb_facebook, $message, $gb_ip, $gb_gtalk, $gb_twitter, $gb_youtube) = split /[|]/xsm, $gb_edit;

    $message =~ s/<br \/>/\n/gsm;
    require Sources::PostBox;
    require Sources::ContextHelp;
    ContextScript('post');
    if ($en_gbspellcheck && $enable_spell_check) {
        $yyinlinestyle .= googiea();
        $yyinlinestyle .= qq~\n<script type="text/javascript" src="$yyhtml_root/AJS.js"></script>~;
        my $userdefaultlang = (split(/-/, $abbr_lang))[0];
        $userdefaultlang ||= 'en';
        $guestbook_spellcheck .= googie($userdefaultlang);
    }

    if ($en_gbsmilies) {
        $gbsmilie_bar = smilies_list();
    }

    if ($en_gbbbcode) {
        $gbbbcode_bar .= postbox();
    }
    $gbbbcode_bar .= postbox2();
    $gbbbcode_bar .= postbox3();
    $gbbbcode .= my_check_prev();
    $gbbbcode .= qq~\n<script type="text/javascript">~;
    $gbbbcode .= my_liveprev();
    $gbbbcode .= qq~</script>\n~;

    if ($en_gbmorefields) {
        $gbfields = $gbmorefields;
        $gbfields =~ s/{yabb gb_icq}/ value="$gb_icq"/gsm;
        $gbfields =~ s/{yabb gb_aim}/ value="$gb_aim"/gsm;
        $gbfields =~ s/{yabb gb_yim}/ value="$gb_yim"/gsm;
        $gbfields =~ s/{yabb gb_skype}/ value="$gb_skype"/gsm;
        $gbfields =~ s/{yabb gb_myspace}/ value="$gb_myspace"/gsm;
        $gbfields =~ s/{yabb gb_gtalk}/ value="$gb_gtalk"/gsm;
        $gbfields =~ s/{yabb gb_twitter}/ value="$gb_twitter"/gsm;
        $gbfields =~ s/{yabb gb_youtube}/ value="$gb_youtube"/gsm;
        $gbfields =~ s/{yabb gb_facebook}/ value="$gb_facebook"/gsm;
    }
    $yymain .= $guestbookedit;
    $yymain =~ s/{yabb name}/$name/gsm;
    $yymain =~ s/{yabb email}/$email/gsm;
    $yymain =~ s/{yabb location}/$location/gsm;
    $yymain =~ s/{yabb gbmorefields}/$gbfields/gsm;
    $yymain =~ s/{yabb gbbbcode_bar}/$gbbbcode_bar/gsm;
    $yymain =~ s/{yabb guestbook_spellcheck}/$guestbook_spellcheck/gsm;
    $yymain =~ s/{yabb textfield}/$textfield/gsm;
    $yymain =~ s/{yabb gbsmilie_bar}/$gbsmilie_bar/gsm;
    $yymain =~ s/{yabb gb_date}/$gb_date/gsm;
    $yymain .= $ctmain;
    $yymain .= $gbbbcode;

    $yytitle = $Guestbook_txt{'33'};
    template();
    exit;
}

sub EditGBMessages2 {
    if ( !$iamadmin && !$iamgmod && !$iamfmod ) { fatal_error('no_access'); }
    $gb_date = $FORM{'gb_date'};
    $name = $FORM{'name'};
    $location = $FORM{'location'};
    $email = $FORM{'email'};
    $website = $FORM{'website'};
    $gb_icq = $FORM{'gb_icq'};
    $gb_aim = $FORM{'gb_aim'};
    $gb_yim = $FORM{'gb_yim'};
    $gb_skype = $FORM{'gb_skype'};
    $gb_myspace = $FORM{'gb_myspace'};
    $gb_facebook = $FORM{'gb_facebook'};
    $message = $FORM{'message'};
    FromChars($message);
    ToHTML($message);
    $message =~ s~[\n\r]{1,2}~<br />~g;
    ToChars($message);
    $gb_ip = $FORM{'gb_ip'};

    fopen(GBOOK, "<$vardir/guestbook/guestbook.txt") or croak "cannot_open $vardir/guestbook/guestbook.txt";
    @messages = <GBOOK>;
    fclose(GBOOK);

    if ($name eq q{}) {fatal_error('no_name');}
    if ($message eq q{}) {fatal_error('no_message');}
    if ( length($email) > 100) {fatal_error('email_to_long');}
    if ($gb_icq !~ /^[0-9]*$/) {fatal_error('icq_only_numbers_allowed');}

    @message = grep (!/$gb_date/, @messages);
    push @message, "$gb_date|$name|$location|$email|$website|$gb_icq|$gb_aim|$gb_yim|$gb_skype|$gb_myspace|$gb_facebook|$message|$user_ip|$gb_gtalk|$gb_twitter|$gb_youtube|";
    $message = join(q{}, @message);

    fopen(GBOOK, ">$vardir/guestbook/guestbook.txt") or fatal_error('cannot_open',"$vardir/guestbook/guestbook.txt", 1);
    print GBOOK "$message\n";
    fclose(GBOOK);
#    if ($action eq 'editgbmessages2') {
#        $yySetLocation = qq~$scripturl?action=guestbook~;
#        redirectexit();
#    }
    $yymain .= qq~<p class="center">$Guestbook_txt{'25b'}<br /><br /><a href="$scripturl?action=guestbook">$Guestbook_txt{'26'}</a></p>~;
    template();
    return;
}

1;